#include "c3dtypes.h"
#include "arrayfuncs.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int TestFunc(int x) {
    x = x + 1;
    return x;
}

Object3D ReadObjectFromFile(char * fname) {
    Object3D out;
    Vector3 *VertexArray = malloc(10000 * sizeof(Vector3));
    int VertexArrayLength = 0;

    TriArray tarr;
    tarr.arr = malloc(10000 * sizeof(Tri));
    tarr.length = 0;

    out.triangles = &tarr;

    strncpy(out.name, fname, 100);

    FILE *f = fopen(fname, "r");

    while (true) {
        char t[500];
        char *fgetres = fgets(t, 500, f);
        if (fgetres == NULL) {
            break;
        }

        char objtype[10];
        char v1[100];
        char v2[100];
        char v3[100];
        sscanf(t, "%s %s %s %s", objtype, v1, v2, v3);
        if (strcmp(objtype, "v") == 0) {
            VertexArray[VertexArrayLength].x = atof(v1)*100;
            VertexArray[VertexArrayLength].y = atof(v2)*100;
            VertexArray[VertexArrayLength].z = atof(v3)*100;
            VertexArrayLength = VertexArrayLength + 1;
        }
        if (strcmp(objtype, "f") == 0 ) {
            // TODO: append face to triarry
            Tri temptri;


            temptri.a = VertexArray[ atoi(v1) - 1];
            temptri.b = VertexArray[ atoi(v2) - 1];
            temptri.c = VertexArray[ atoi(v3) - 1];

			printf("OLINE: %s\n", t);
			printf("adding tri A: %d, B: %d, C: %d\n", atoi(v1), atoi(v2) , atoi(v3) );
			
			temptri.color = GREEN;
			TriArrayAppend(&tarr, temptri);
        }
        // need to bring in triarray functions into their own file
    }

	return out;

    // TODO: use file object and read each line
    //  add verticies to the vertex list, +1 ing the length value each time
    //  just fucking parse the obj file its not that hard
}
